################################################################################
#
# Advanced m4 macros file.
# Copyright (c) 2002-2006 Oak Ridge National Laboratory.
#
# For more information see the following files in the source distribution top-
# level directory or package data directory (usually /usr/local/share/package):
#
# - README    for general package information.
# - INSTALL   for package install information.
# - COPYING   for package license information and copying conditions.
# - AUTHORS   for package authors information.
# - ChangeLog for package changes information.
#
# This file is automatically included by aclocal using `autogen.sh`.
#
################################################################################

#
# Defines and substitutes binary specific package information needed for
# version control and autoheader header file information.
#
# $1 = The binary (all capital letters or underscores w/o any suffix).
# $2 = The current version number.
# $3 = The current revision number.
# $4 = The current version age.
#
AC_DEFUN([RMIX_DEFINE],[
$1_VERSION_CURRENT=$2
$1_VERSION_REVISION=$3
$1_VERSION_AGE=$4
$1_VERSION=`expr $2 - $3`.$4.$3
AC_DEFINE_UNQUOTED([$1_PACKAGE_NAME],      [$PACKAGE_NAME])
AC_DEFINE_UNQUOTED([$1_PACKAGE_VERSION],   [$PACKAGE_VERSION])
AC_DEFINE_UNQUOTED([$1_PACKAGE_RELEASE],   [$PACKAGE_RELEASE])
AC_DEFINE_UNQUOTED([$1_PACKAGE_BUGREPORT], [$PACKAGE_BUGREPORT])
AC_DEFINE_UNQUOTED([$1_PACKAGE_LABEL],     [$PACKAGE_LABEL])
AC_DEFINE_UNQUOTED([$1_VERSION_CURRENT])
AC_DEFINE_UNQUOTED([$1_VERSION_REVISION])
AC_DEFINE_UNQUOTED([$1_VERSION_AGE])
AC_DEFINE_UNQUOTED([$1_VERSION_FIRST])
AC_DEFINE_UNQUOTED([$1_VERSION])
AC_SUBST([$1_VERSION_CURRENT])
AC_SUBST([$1_VERSION_REVISION])
AC_SUBST([$1_VERSION_AGE])
AC_SUBST([$1_VERSION_FIRST])
AC_SUBST([$1_VERSION])
])

#
# Creates and versions library links for local install header and library
# directories needed to include headers and link libraries within packages
# and across bundled packages without installing them.
#
# $1 = The binary (w/o any pre- or suffix).
# $2 = The binary (all capital letters or underscores w/o any pre- or suffix).
#
AC_DEFUN([RMIX_LIBRARY],[
VER=${LIB$2_VERSION}
CUR=${LIB$2_VERSION_CURRENT}
AGE=${LIB$2_VERSION_AGE}
ln -s ../lib$1 include/$1.$VER
ln -s ../lib$1/.libs/lib$1.$VER.la       lib/lib$1.$VER.la
ln -s ../lib$1/.libs/lib$1.$VER.a        lib/lib$1.$VER.a
ln -s ../lib$1/.libs/lib$1.$VER.so       lib/lib$1.$VER.so
ln -s ../lib$1/.libs/lib$1.$VER.debug.a  lib/lib$1.$VER.debug.a
ln -s ../lib$1/.libs/lib$1.$VER.debug.so lib/lib$1.$VER.debug.so
./autolink.sh --file=include/$1                   --current=$CUR --age=$AGE
./autolink.sh --file=lib/lib$1 --suffix=.so       --current=$CUR --age=$AGE
./autolink.sh --file=lib/lib$1 --suffix=.a        --current=$CUR --age=$AGE
./autolink.sh --file=lib/lib$1 --suffix=.debug.a  --current=$CUR --age=$AGE
./autolink.sh --file=lib/lib$1 --suffix=.debug.so --current=$CUR --age=$AGE
])

################################################################################
#
# End of file.
#
################################################################################
